//============================================================================
// Name        : AbstractFactory.cpp
// Author      :
// Version     :
// Copyright   :
// Description : Test the Abstract Factory pattern
//============================================================================

#include <iostream>
#include "WidgetFactory.h"
#include "WinFactory.h"
#include "GTKFactory.h"
#include "Widget.h"
using namespace std;

int main() {
	cout << "Abstract Factory Test" << endl;
	WidgetFactory* factory;

	// decide which factory to use at compile time. Windows compiler define the __WIN symbol
#ifdef __WIN
	factory = new WinFactory;
#else
	factory = new GTKFactory;
#endif

	Widget* button;
	Widget* window;
	// crea bottone e finestra dalla factory
	button = factory->createButton();
	window = factory->createWindow();

	window->draw();
	button->draw();

	return 0;
}
